// ============================================
// [Tv]
// {XVbgǗNX
//
// Copyright (C) 2012 Җ All rights reserved.
// ============================================

#ifndef BOSS_SHOT_H_INCLUDED_
#define BOSS_SHOT_H_INCLUDED_

#include <sstream>
#include "Struct.h"
#include "Common.h"
#include "BossShotPattern.h"

using namespace std;
using namespace CommonSpace;

class BossShot
{
public:
	//RXgN^
	BossShot( void );

	//fXgN^
	~BossShot( void );

	//
	void Initialize();

	//Vbg̑S̊Ǘ
	void ShotControl( const BossData* boss_data, const PlayerData* player_data );

	//Vbg̓o^
	void RegisterShot( int barrage_kind );

	//Vbg̃LZ
	void ShotCancel();

	//Vbg
	void ShotClear( int shot_num, int bullet_num );

	//Vbgf[^Ԃ
	const BossShotData* GetShotData() const;

	//ȇ傫Ԃ
	const vector<Size>* GetBulletSize() const;

private:
	//evZs܂B
	void ShotCalc( const BossData& boss_data, int shot_num );

	// e̕`
	void DrawBossShot();

	//Rs[RXgN^֎~
	BossShot( const BossShot& );

	//֎~
	BossShot& operator=( const BossShot& );

	vector<int> bulletImage;//eۃC[Wnh
	vector<Size> imageSize;//eۉ摜̑傫
	BossShotData shotData[ BOSS_SHOT_SHOW_MAX ];//BOSSVbgf[^
	BossShotPattern shotPattern;//Vbgp^[֐ێNX
};

#endif // BOSS_SHOT_H_INCLUDED_