// ============================================
// [Tv]
// define錾 (DirectX)
//
// Copyright (C) 2012 Җ All rights reserved.
// ============================================

#ifndef DX_DEFINE_H_INCLUDED_
#define DX_DEFINE_H_INCLUDED_

#ifndef SAFE_DELETE
#define SAFE_DELETE( p ) { if (p) { delete ( p ); ( p )=NULL; } }
#endif

#ifndef SAFE_DELETE_ARRAY
#define SAFE_DELETE_ARRAY( p ) { if ( p ) { delete[] ( p ); ( p )=NULL; } }
#endif

#ifndef SAFE_RELEASE
#define SAFE_RELEASE( p ) { if ( p ) { ( p )->Release(); ( p )=NULL; } }
#endif

#ifndef WAVEFILE_READ
#define WAVEFILE_READ 1
#endif

#ifndef WAVEFILE_WRITE
#define WAVEFILE_WRITE 2
#endif

#ifndef MAX_SOUND
#define MAX_SOUND 100
#endif

#ifndef DIRECTINPUT_VERSION
#define DIRECTINPUT_VERSION 0x0900
#endif

#endif //DX_DEFINE_H_INCLUDED_