#include "EnemyMovePattern.h"

//RXgN^ Ȃ
EnemyMovePattern::EnemyMovePattern(void)
{
}

//fXgN^@Ȃ
EnemyMovePattern::~EnemyMovePattern(void)
{
}

//p^[̌vZ@p^[default:͂艺ĂďオĂƂ
void EnemyMovePattern::CalcPattern( EnemyData &enemy_data )
{
	int count = enemy_data.count;

	switch( enemy_data.pattern )
	{
	case 0:
		//ĂĒ؂ďオĂ
		if( count == 0 )
		{
			enemy_data.vec_speed.y = 3.0;
		}
		else if( count == 40 )
		{
			enemy_data.vec_speed.y = 0.0;
		}
		else if( count >= ( 40 + enemy_data.wait_time ) )
		{
			enemy_data.vec_speed.y = -3.0;
		}
		
		break;

	case 1:
		//ĂĒ؂čɍs
		if( count == 0 )
		{
			enemy_data.vec_speed.y = 3.0;
		}
		else if( count == 40 )
		{
			enemy_data.vec_speed.y = 0.0;
		}
		else if( count >= ( 40 + enemy_data.wait_time ) )
		{
			enemy_data.vec_speed.Set( -1.0, -3.0 );
			enemy_data.direction = 0;
		}
		
		break;

	case 2:
		//ĂĒ؂ĉEɍs
		if( count == 0 )
		{
			enemy_data.vec_speed.y = 3.0;
		}
		else if( count == 40 )
		{
			enemy_data.vec_speed.y = 0.0;
		}
		else if( count >= ( 40 + enemy_data.wait_time ) )
		{
			enemy_data.vec_speed.Set( 1.0, 2.0 );
			enemy_data.direction = 0;
		}

		break;

	case 3:
		//΂₭~Ăč
		if( count == 0 )
		{
			enemy_data.vec_speed.y = 5.0;
		}
		else if( count == 30 )
		{
			enemy_data.direction = 2;
		}
		else if( count < 100 )
		{
			enemy_data.vec_speed.x -= 5.0 / 100.0;
			enemy_data.vec_speed.y -= 5.0 / 100.0;
		}

		break;

	case 4:
		//΂₭~ĂĉE
		if( count == 0 )
		{
			enemy_data.vec_speed.y = 5.0;
		}
		else if( count == 30 )
		{
			enemy_data.direction = 2;
		}
		else if( count < 100 )
		{
			enemy_data.vec_speed.x += 5.0 / 100.0;
			enemy_data.vec_speed.y -= 5.0 / 100.0;
		}

		break;

	case 5:
		//΂ߍ
		if( count == 0 )
		{
			enemy_data.vec_speed.x -= 1.0;
			enemy_data.vec_speed.y = 2.0;
			enemy_data.direction = 0;
		}

		break;

	case 6:
		//΂߉E
		if( count == 0 )
		{
			enemy_data.vec_speed.x += 1.0;
			enemy_data.vec_speed.y = 2.0;
			enemy_data.direction = 2;
		}

		break;

	case 7:
		//؂Ă̂܂܍
		if( count >= enemy_data.wait_time )
		{
			enemy_data.vec_speed.x = -0.7;
			enemy_data.vec_speed.y = -0.3;
			enemy_data.direction = 0;
		}

		break;

	case 8:
		//؂Ă̂܂܉E
		if( count >= enemy_data.wait_time )
		{
			enemy_data.vec_speed.x = 0.7;
			enemy_data.vec_speed.y = -0.3;
			enemy_data.direction = 2;
		}

		break;

	case 9:
		//؂Ă̂܂܏
		if( count >= enemy_data.wait_time )
		{
			enemy_data.vec_speed.y = -1;
		}

		break;

	case 10:
		//ăEEĂĂ
		if( count == 0 )
		{
			enemy_data.vec_speed.y = 4.0;
		}

		if( count == 40 )
		{
			enemy_data.vec_speed.y = 0;
		}

		if( count >= 40 )
		{
			if( count % 60 == 0 )
			{
				int range = cos( enemy_data.angle ) < 0 ? 0 : 1;
				enemy_data.speed = 6 + RandomNumber( 2 );
				enemy_data.angle = RandomNumber( CIRCLE_RATIO / 4 ) + CIRCLE_RATIO * range;
				enemy_data.direction = 2 - 2 * range;
			}

			enemy_data.speed *= 0.95;
		}

		if( count >= enemy_data.wait_time )
		{
			enemy_data.vec_speed.y -= 0.05;
		}

		break;

	default:
		//ĂďオĂ
		if( count == 0 )
		{
			enemy_data.vec_speed.y = 1.0;
		}
		else if( count >= 60 )
		{
			enemy_data.vec_speed.y = -1.0;
		}

		break;
	}
}