// ============================================
// [Tv]
// GVbgǗNX
//
// Copyright (C) 2012 Җ All rights reserved.
// ============================================

#ifndef ENEMYSHOT_H_INCLUDED_
#define ENEMYSHOT_H_INCLUDED_

#include <sstream>
#include "Struct.h"
#include "Common.h"
#include "EnemyShotPattern.h"

using namespace std;
using namespace CommonSpace;

class EnemyShot
{
public:
	//RXgN^
	EnemyShot( void );

	//fXgN^
	~EnemyShot( void );

	//
	void Initialize();

	//VbgS̊Ǘ
	void ShotControl( const EnemyData* enemy_data, const PlayerData* player_data );

	//Vbg̓o^
	void RegisterShot( int enemy_num, int barrage_kind );

	//Vbg̃LZ
	void ShotCancel( int enemy_num );

	//Vbg
	void ShotClear( int shot_num, int bullet_num );

	//Vbgf[^Ԃ
	const EnemyShotData* GetShotData() const;

	//ȇ傫Ԃ
	const vector<Size>* GetBulletSize() const;

private:
	//evZs܂B
	void ShotCalc( const EnemyData* enemy_data, int shot_num );

	// e̕`
	void DrawEnemyShot();

	//Rs[RXgN^֎~
	EnemyShot( const EnemyShot& );

	//֎~
	EnemyShot& operator=( const EnemyShot& );

	vector<int> bulletImage;//eۃC[Wnh
	vector<Size> imageSize;//eۉ摜̑傫
	EnemyShotData shotData[ EN_SHOT_SHOW_MAX ];//GVbgf[^
	EnemyShotPattern shotPattern;//Vbgp^[֐ێNX
};

#endif //ENEMYSHOT_H_INCLUDED_