#include "EnemyShotPattern.h"

EnemyShotPattern::EnemyShotPattern(void)
{
	//GVbg̉͑SēƂBeɂĕςȂbullet_kind̒lɑΉ悤ɂB
	shotSound.push_back( DX::dxCentral.LoadWaveSound( L"./SettingFiles/Sound/EnemyShot.wav", false ) );
}

EnemyShotPattern::~EnemyShotPattern(void)
{
}

//ẽp^[Zbg܂B
void EnemyShotPattern::ShotPattern( EnemyShotData& shot_data, const EnemyData& enemy_data, const PlayerData& player_data )
{
	int count = 0;

	switch( shot_data.kind )
	{
	case 0:
		//1Al@ɌĒ
		if( shot_data.count == 0 )
		{
			int empty_num = SearchEmptyBullet( &shot_data.bullet[ 0 ] );

			if( shot_data.flag != 2 && empty_num != -1 )
			{
				shot_data.bullet[ empty_num ].flag = 1;
				shot_data.bullet[ empty_num ].kind = enemy_data.bullet_kind;
				shot_data.bullet[ empty_num ].angle = ShotAtan2( enemy_data.location, player_data.location );
				shot_data.bullet[ empty_num ].location.Set( enemy_data.location.x, enemy_data.location.y );
				shot_data.bullet[ empty_num ].count = 0;
				shot_data.bullet[ empty_num ].speed = 3;
				DX::dxCentral.PlayWaveSound( shotSound[ 0 ] );
			}
		}

		break;

	case 1:
		//100JEg5Al@ɌĒ(pxL)
		count = shot_data.count;

		if( count >= 0 && count < 100 && count % 20 == 0 )
		{
			if( count == 0 )
			{
				shot_data.angle = ShotAtan2( enemy_data.location, player_data.location );
			}

			int empty_num = SearchEmptyBullet( &shot_data.bullet[ 0 ] );

			if( shot_data.flag != 2 && empty_num != -1 )
			{
				shot_data.bullet[ empty_num ].flag = 1;
				shot_data.bullet[ empty_num ].kind = enemy_data.bullet_kind;
				shot_data.bullet[ empty_num ].angle = shot_data.angle;
				shot_data.bullet[ empty_num ].location.Set( enemy_data.location.x, enemy_data.location.y );
				shot_data.bullet[ empty_num ].count = 0;
				shot_data.bullet[ empty_num ].speed = 3;
				DX::dxCentral.PlayWaveSound( shotSound[ 0 ] );
			}
		}

		break;

	case 2:
		//100JEg5Al@ɌăXs[hω
		count = shot_data.count;

		if( count >= 0 && count < 100 && count % 20 == 0 )
		{
			int empty_num = SearchEmptyBullet( &shot_data.bullet[ 0 ] );

			if( shot_data.flag != 2 && empty_num != -1 )
			{
				shot_data.bullet[ empty_num ].flag = 1;
				shot_data.bullet[ empty_num ].kind = enemy_data.bullet_kind;
				shot_data.bullet[ empty_num ].angle = ShotAtan2( enemy_data.location, player_data.location );
				shot_data.bullet[ empty_num ].location.Set( enemy_data.location.x, enemy_data.location.y );
				shot_data.bullet[ empty_num ].count = 0;
				shot_data.bullet[ empty_num ].speed = 1 + 5.0 / 100 * count;//ŕω
				DX::dxCentral.PlayWaveSound( shotSound[ 0 ] );
			}
		}

		break;

	case 3:
		//~`
		count = shot_data.count;

		if( count >= 0 && count < 120 && count % 60 == 0 )
		{
			double angle = ShotAtan2( enemy_data.location, player_data.location );

			for( int i = 0; i < 20; i++ )
			{
				int empty_num = SearchEmptyBullet( &shot_data.bullet[ 0 ] );

				if( shot_data.flag != 2 && empty_num != -1 )
				{
					shot_data.bullet[ empty_num ].flag = 1;
					shot_data.bullet[ empty_num ].kind = enemy_data.bullet_kind;
					shot_data.bullet[ empty_num ].angle = angle + CIRCLE_RATIO * 2 / 20 * i;
					shot_data.bullet[ empty_num ].location.Set( enemy_data.location.x, enemy_data.location.y );
					shot_data.bullet[ empty_num ].count = 0;
					shot_data.bullet[ empty_num ].speed = 4;
					DX::dxCentral.PlayWaveSound( shotSound[ 0 ] );
				}
			}
		}

		break;

	case 4:
		//΂܂Vbg
		count = shot_data.count;

		if( count >= 0 && count < 120 && count % 6 == 0 )
		{
			int empty_num = SearchEmptyBullet( &shot_data.bullet[ 0 ] );

			if( shot_data.flag != 2 && empty_num != -1 )
			{
				if( shot_data.flag != 2 && empty_num != -1 )
				{
					shot_data.bullet[ empty_num ].flag = 1;
					shot_data.bullet[ empty_num ].kind = enemy_data.bullet_kind;
					shot_data.bullet[ empty_num ].angle = ShotAtan2( enemy_data.location, player_data.location ) + RandomNumber( CIRCLE_RATIO / 4 );
					shot_data.bullet[ empty_num ].location.Set( enemy_data.location.x, enemy_data.location.y );
					shot_data.bullet[ empty_num ].count = 0;
					shot_data.bullet[ empty_num ].speed = 3 + RandomNumber( 1.5 );//͓Kɔ
					DX::dxCentral.PlayWaveSound( shotSound[ 0 ] );
				}
			}
		}

		break;

	case 5:
		//΂܂Vbgij
		count = shot_data.count;

		if( count >= 0 && count < 120 && count % 6 == 0 )
		{
			int empty_num = SearchEmptyBullet( &shot_data.bullet[ 0 ] );

			if( shot_data.flag != 2 && empty_num != -1 )
			{
				if( shot_data.flag != 2 && empty_num != -1 )
				{
					shot_data.bullet[ empty_num ].flag = 1;
					shot_data.bullet[ empty_num ].kind = enemy_data.bullet_kind;
					shot_data.bullet[ empty_num ].angle = ShotAtan2( enemy_data.location, player_data.location ) + RandomNumber( CIRCLE_RATIO / 4 );
					shot_data.bullet[ empty_num ].location.Set( enemy_data.location.x, enemy_data.location.y );
					shot_data.bullet[ empty_num ].count = 0;
					shot_data.bullet[ empty_num ].speed = 4 + RandomNumber( 2 );//͓Kɔ
					DX::dxCentral.PlayWaveSound( shotSound[ 0 ] );
				}
			}

			for( int i = 0; i < BULLET_DATA_MAX; i++ )
			{
				if( shot_data.bullet[i].speed > 1.5 )
				{
					shot_data.bullet[i].speed -= 0.04;
				}
			}
		}

		break;

	default:
		//1Al@ɌĒ
		if( shot_data.count == 0 )
		{
			int empty_num = SearchEmptyBullet( &shot_data.bullet[ 0 ] );

			if( shot_data.flag != 2 && empty_num != -1 )
			{
				shot_data.bullet[ empty_num ].flag = 1;
				shot_data.bullet[ empty_num ].kind = enemy_data.bullet_kind;
				shot_data.bullet[ empty_num ].angle = ShotAtan2( enemy_data.location, player_data.location );
				shot_data.bullet[ empty_num ].location.Set( enemy_data.location.x, enemy_data.location.y );
				shot_data.bullet[ empty_num ].count = 0;
				shot_data.bullet[ empty_num ].speed = 3;
				DX::dxCentral.PlayWaveSound( shotSound[ 0 ] );
			}
		}

		break;
	}
}

//shot_num̃Vbgo^GƎlƂ̊pxԂB
double EnemyShotPattern::ShotAtan2( const Point& enemy_loc, const Point& player_loc )
{
	return atan2( 
		player_loc.y - enemy_loc.y,
		player_loc.x - enemy_loc.x );
}

//󂢂Ăeۂ̌
int EnemyShotPattern::SearchEmptyBullet( const BulletData* bullet_data )
{
	if( bullet_data )
	{
		for( int i = 0; i < BULLET_DATA_MAX; i++ )
		{
			if( bullet_data[ i ].flag == 0 )
			{
				return i;
			}
		}

		return -1;
	}

	return -1;
}