#include "GameOver.h"

namespace Sequence
{
	//RXgN^
	GameOver::GameOver(void) : gameOverImage( -1 ),
		imageShowCount( 0 ),
		gameOverSound( -1 )
	{
		//摜ǂݍ&ǂݍ
		gameOverImage = DX::dxCentral.LoadTexture( "./SettingFiles/GameOver/GameOverImage.png" );
		gameOverSound = DX::dxCentral.LoadWaveSound( L"./SettingFiles/Sound/CharcterDeath.wav", false );

		if( gameOverImage == -1 || gameOverSound == -1 )
		{
			ErrorMsgBox( "GameOver摜or̓ǂݍ݂Ɏs܂B\nI܂B" );
			exit( -1 );
		}

		DX::dxCentral.PlayWaveSound( gameOverSound );
	}

	//fXgN^
	GameOver::~GameOver(void)
	{
		DX::dxCentral.DeleteAllTexture();
		DX::dxCentral.DeleteAllSound();
	}

	//ʍXV
	void GameOver::Update( SequenceCentral* central )
	{
		if( imageShowCount == 200 )
		{
			central->MoveSequence( NEXT_TITLE );
		}

		DX::dxCentral.DrawTexture(
			gameOverImage,
			0,
			0,
			WINDOW_SIZE_X,
			WINDOW_SIZE_Y,
			0,
			0,
			WINDOW_SIZE_X,
			WINDOW_SIZE_Y );

		imageShowCount++;
	}
}