#include "GamePause.h"

namespace Sequence
{
	namespace GameSequence
	{
		//RXgN^
		GamePause::GamePause( void ) : gamePauseImage( -1 ),
			pauseSound( -1 )
		{
			gamePauseImage = DX::dxCentral.LoadTexture( "./SettingFiles/Pause/PauseImage.png" );
			pauseSound = DX::dxCentral.LoadWaveSound( L"./SettingFiles/Sound/Enter.wav", false );//Ƃ肠G^[ƈꏏ

			if( gamePauseImage == -1 || pauseSound == -1)
			{
				ErrorMsgBox( "Pause摜or̓ǂݍ݂Ɏs܂B\nI܂B" );
				exit( -1 );
			}

			DX::dxCentral.PlayWaveSound( pauseSound );
		}

		//fXgN^
		GamePause::~GamePause( void )
		{
			DX::dxCentral.DeleteTexture( gamePauseImage );
		}

		//ʂ̍XV
		void GamePause::Update( GameSequenceCentral* game_sequence_central )
		{
			DX::dxCentral.DrawTexture(
				gamePauseImage,
				0,
				0,
				WINDOW_SIZE_X,
				WINDOW_SIZE_Y,
				0,
				0,
				WINDOW_SIZE_X,
				WINDOW_SIZE_Y );

			const char* keys = DX::dxCentral.GetKeyState();//̊֐͂炩ɐ݌v~XB
			const int* key_count = DX::dxCentral.GetKeyCount();

			if( key_count[ DIK_P ] > 0 )
			{
				game_sequence_central->MoveGameSequence( NEXT_GAME_PAUSE_CLEAR );
			}
		}
	}
}