#include "Title.h"

namespace Sequence
{
	//RXgN^
	Title::Title( void ) : titleImage( -1 )
	{
		//摜ǂݍ
		titleImage = DX::dxCentral.LoadTexture( "./SettingFiles/Title/TitleImage.png" );

		if( titleImage == -1 )
		{
			ErrorMsgBox( "Title摜̓ǂݍ݂Ɏs܂B\nI܂B" );
			exit( -1 );
		}
	}

	//fXgN^
	Title::~Title( void )
	{
		DX::dxCentral.DeleteAllTexture();
		DX::dxCentral.DeleteAllSound();
	}

	//ʍXV
	void Title::Update( SequenceCentral* central )
	{
		const char* keys = DX::dxCentral.GetKeyState();
		const int* key_count = DX::dxCentral.GetKeyCount();

		if( key_count[ DIK_RETURN ] > 0 )
		{
			central->MoveSequence( NEXT_GAME );
		}

		DX::dxCentral.DrawTexture(
			titleImage,
			0,
			0,
			WINDOW_SIZE_X,
			WINDOW_SIZE_Y,
			0,
			0,
			WINDOW_SIZE_X,
			WINDOW_SIZE_Y );
	}
}