#include "BackGround.h"

//RXgN^@Kwi摜ǂݍށBG[Ȃ~߂B
BackGround::BackGround(void) : drawCount( 0 ),
	frameImage( -1 )
{
	for( int i = 0; i < MAX_STAGE; i++ )
	{
		std::ostringstream image_path;

		image_path << "./SettingFiles/BackGround/Back" << ( i + 1 ) << ".png";

		backGroundImage.push_back( ImageData( DX::dxCentral.LoadTexture( image_path.str().c_str() ), Size( 384, 700 ), Size( 384, 700 ) ) );

		if( backGroundImage[ i ].image == -1 )
		{
			ErrorMsgBox( "wiC[W̓ǂݍ݃G[B\nI܂B" );
			exit( -1 );
		}
	}

	frameImage = DX::dxCentral.LoadTexture( "./SettingFiles/Frame/Frame.png" );

	if( frameImage == -1 )
	{
		ErrorMsgBox( "t[C[W̓ǂݍ݃G[B\nI܂B" );
		exit( -1 );
	}
}

//fXgN^@ɏ\ȂB
BackGround::~BackGround(void)
{
}

//wi
void BackGround::Control( int stage_num )
{
	CalcBackGround( stage_num );//vZB
}

//wi摜`vZ
void BackGround::CalcBackGround( int stage_num )
{
	if( stage_num >= MAX_STAGE )
	{
		ErrorMsgBox( "wi`G[I@Xe[WԍsłB\nI܂B" );
		exit( -1 );
	}

	//XN[\邽߂2wi摜`KvBNbsOɂ関`hߎ2xg~OvZKvB
	//WINDOW_SIZE_Y𒴂ꍇ͕\Ă܂Ȃ̂ŉȂB܂菈̂Yl0ȉ or 0ȏ[WINDOW_SIZE_Y]̎
	for( int i = 0; i < 2; i++ )
	{
		int draw_loc_y = ( drawCount % backGroundImage[ stage_num ].size.height ) - ( backGroundImage[ stage_num ].size.height * i );
		int trim_height;//g~O̕`Ώۉ摜̍
		RectData trim_rect;//摜̃g~Of[^

		if( draw_loc_y < 0 )
		{
			trim_height = backGroundImage[ stage_num ].size.height + draw_loc_y;//...size.height - abs(draw_loc_y)ƓӖ

			if( trim_height > WINDOW_SIZE_Y )//EBhE𒴂ĂȂ摜̏㉺g~OiNbsO΍j
			{
				trim_rect.Set( 
					-draw_loc_y,
					0,
					WINDOW_SIZE_Y - draw_loc_y,
					backGroundImage[ stage_num ].size.width );

				trim_height = WINDOW_SIZE_Y;
			}
			else//EBhE𒴂ĂȂȂ摜̏㕔g~OiNbsO΍j
			{
				trim_rect.Set( 
					backGroundImage[ stage_num ].size.height - trim_height,
					0,
					backGroundImage[ stage_num ].size.height,
					backGroundImage[ stage_num ].size.width );
			}

			DrawBackGround( stage_num, trim_rect, LIMIT_SCOPE_START_X, 0, backGroundImage[ stage_num ].size.width, trim_height );
		}
		else if( draw_loc_y >= 0 && draw_loc_y < WINDOW_SIZE_Y )
		{
			trim_rect.Set( 
				0,
				0,
				WINDOW_SIZE_Y - draw_loc_y,
				backGroundImage[ stage_num ].size.width );

			trim_height = WINDOW_SIZE_Y - draw_loc_y;

			DrawBackGround( stage_num, trim_rect, LIMIT_SCOPE_START_X, draw_loc_y, backGroundImage[ stage_num ].size.width, trim_height );
		}
	}

	//wi`t[`悷
	DX::dxCentral.DrawTexture(
		frameImage,
		0,
		0,
		WINDOW_SIZE_X,
		WINDOW_SIZE_Y,
		0,
		0,
		WINDOW_SIZE_X,
		WINDOW_SIZE_Y );

	drawCount++;
}

//`
void BackGround::DrawBackGround( int stage_num, RectData& rect, int draw_x, int draw_y, int width, int height )
{
	if( stage_num >= MAX_STAGE )
	{
		ErrorMsgBox( "wi`G[I@Xe[WԍsłB\nI܂B" );
		exit( -1 );
	}

	DX::dxCentral.DrawTexture(
		backGroundImage[ stage_num ].image,
		rect.left,
		rect.top,
		rect.right,
		rect.bottom,
		draw_x,
		draw_y,
		width,
		height );
}