// ============================================
// [Tv]
// {XǗNX
//
// Copyright (C) 2012 Җ All rights reserved.
// ============================================

#ifndef BOSS_H_INCLUDED_
#define BOSS_H_INCLUDED_

#include "Common.h"
#include "Struct.h"
#include "XmlReader.h"
#include "BossMovePattern.h"
#include "BossShot.h"
#include "ExplosionEffect.h"

using namespace CommonSpace;

class Boss
{
public:
	//RXgN^
	Boss( void );

	//fXgN^
	~Boss( void );

	//
	void Initialize( int stage_num );

	//{XǗ
	void BossControl( const PlayerData* player );

	//{X̃_[W
	int BossDamage( int damage );

	//{Xf[^Ԃ
	const BossData* GetBossData() const;

	//{XVbgf[^Ԃ
	const BossShotData* GetShotData() const;

	//ȇ傫Ԃ
	const vector<Size>* GetBulletSize() const;

private:
	//`
	void DrawBossImage();

	//{Xf[^̓ǂݍ
	void LoadBossFile( int stage_num );

	//Rs[RXgN^̋֎~
	Boss( const Boss& );

	//Rs[Zq̋֎~
	Boss& operator=( const Boss& );

	std::vector<int> bossImage;//{XC[W
	std::vector<int> soundHandle;//TEhnh
	std::vector<std::string> fileName;//{Xf[^t@C
	BossData bossData;//{Xf[^
	BossMovePattern movePattern;//{Xړp^[ǗNX
	BossShot bossShot;//VbgǗNX
	ExplosionEffect bossEffect;//{XGtFNgǗNX
};

#endif //BOSS_H_INCLUDED_