#include "BossShotPattern.h"

//RXgN^
BossShotPattern::BossShotPattern(void)
{
	shotSound.push_back( DX::dxCentral.LoadWaveSound( L"./SettingFiles/Sound/EnemyShot.wav", false ) );//hC特͓GƓ
}

//fXgN^
BossShotPattern::~BossShotPattern(void)
{
}

//ẽp^[Zbg܂B
void BossShotPattern::ShotPattern( BossShotData& shot_data, const BossData& boss_data, const PlayerData& player_data )
{
	int empty_num = -1;

	switch( shot_data.kind )
	{
	case 0:
		//100JEg܂ŘAˁǍATOJEguɎˌATOOJEgōŏ̘A˂...i[vj
		if( ( shot_data.count < 100 && shot_data.count % 10 == 0 ) || ( shot_data.count >= 100 && shot_data.count % 50 == 0 ) )
		{
			empty_num = SearchEmptyBullet( &shot_data.bullet[ 0 ] );

			if( shot_data.flag != 2 && empty_num != -1 )
			{
				shot_data.bullet[ empty_num ].flag = 1;
				shot_data.bullet[ empty_num ].kind = 1;//boss_data.bullet_kind;
				shot_data.bullet[ empty_num ].angle = ShotAtan2( boss_data.location, player_data.location );
				shot_data.bullet[ empty_num ].location.Set( boss_data.location.x, boss_data.location.y );
				shot_data.bullet[ empty_num ].count = 0;
				shot_data.bullet[ empty_num ].speed = 3;
				DX::dxCentral.PlayWaveSound( shotSound[ 0 ] );
			}
		}

		if( shot_data.count >= 500 )
		{
			shot_data.count = 0;
		}

		break;

	case 1:
		//40JEgɈVbg@100JEgƂɉ~`, TOOJEgōŏ̘A˂...i[vj
		if( shot_data.count % 40 == 0 )
		{
			empty_num = SearchEmptyBullet( &shot_data.bullet[ 0 ] );

			if( shot_data.flag != 2 && empty_num != -1 )
			{
				shot_data.bullet[ empty_num ].flag = 1;
				shot_data.bullet[ empty_num ].kind = boss_data.bullet_kind;
				shot_data.bullet[ empty_num ].angle = ShotAtan2( boss_data.location, player_data.location );
				shot_data.bullet[ empty_num ].location.Set( boss_data.location.x, boss_data.location.y );
				shot_data.bullet[ empty_num ].count = 0;
				shot_data.bullet[ empty_num ].speed = 3;
				DX::dxCentral.PlayWaveSound( shotSound[ 0 ] );
			}
		}

		if( shot_data.count > 100 && shot_data.count < 200 && shot_data.count % 20 == 0 )
		{
			for( int i = 0; i < 20; i++ )
			{
				empty_num = SearchEmptyBullet( &shot_data.bullet[ 0 ] );

				if( shot_data.flag != 2 && empty_num != -1 )
				{
					shot_data.bullet[ empty_num ].flag = 1;
					shot_data.bullet[ empty_num ].kind = boss_data.bullet_kind;
					shot_data.bullet[ empty_num ].angle = ShotAtan2( boss_data.location, player_data.location ) + CIRCLE_RATIO * 2 / 20 * i;
					shot_data.bullet[ empty_num ].location.Set( boss_data.location.x, boss_data.location.y );
					shot_data.bullet[ empty_num ].count = 0;
					shot_data.bullet[ empty_num ].speed = 4;
					DX::dxCentral.PlayWaveSound( shotSound[ 0 ] );
				}
			}
		}

		if( shot_data.count >= 500 )
		{
			shot_data.count = 0;
		}

		break;

	case 2:
		//10AˌA50JEgÂVbg@300JEg𒴂ŉ~`˒ǉB TOOJEgōŏ̘A˂...i[vj
		if( ( shot_data.count < 100 && shot_data.count % 10 == 0 ) || ( shot_data.count >= 100 && shot_data.count % 50 == 0 ) )
		{
			empty_num = SearchEmptyBullet( &shot_data.bullet[ 0 ] );

			if( shot_data.flag != 2 && empty_num != -1 )
			{
				shot_data.bullet[ empty_num ].flag = 1;
				shot_data.bullet[ empty_num ].kind = boss_data.bullet_kind;
				shot_data.bullet[ empty_num ].angle = ShotAtan2( boss_data.location, player_data.location );
				shot_data.bullet[ empty_num ].location.Set( boss_data.location.x, boss_data.location.y );
				shot_data.bullet[ empty_num ].count = 0;
				shot_data.bullet[ empty_num ].speed = 3;
				DX::dxCentral.PlayWaveSound( shotSound[ 0 ] );
			}
		}

		if( shot_data.count > 300 && shot_data.count < 400 && shot_data.count % 20 == 0 )
		{
			for( int i = 0; i < 20; i++ )
			{
				empty_num = SearchEmptyBullet( &shot_data.bullet[ 0 ] );

				if( shot_data.flag != 2 && empty_num != -1 )
				{
					shot_data.bullet[ empty_num ].flag = 1;
					shot_data.bullet[ empty_num ].kind = 2;//łAʔȂ̂Œe̎ނςBzgboss_data.bullet_kind̂؁B
					shot_data.bullet[ empty_num ].angle = ShotAtan2( boss_data.location, player_data.location ) + CIRCLE_RATIO * 2 / 20 * i;
					shot_data.bullet[ empty_num ].location.Set( boss_data.location.x, boss_data.location.y );
					shot_data.bullet[ empty_num ].count = 0;
					shot_data.bullet[ empty_num ].speed = 4;
					DX::dxCentral.PlayWaveSound( shotSound[ 0 ] );
				}
			}
		}

		if( shot_data.count >= 500 )
		{
			shot_data.count = 0;
		}

		break;

	case 3:
		//10AˌA50JEgÂVbg@200JEg𒴂ł΂TA300JEgŉ~`˒ǉB TOOJEgōŏ̘A˂...i[vj
		if( ( shot_data.count < 100 && shot_data.count % 10 == 0 ) || ( shot_data.count >= 100 && shot_data.count % 50 == 0 ) )
		{
			empty_num = SearchEmptyBullet( &shot_data.bullet[ 0 ] );

			if( shot_data.flag != 2 && empty_num != -1 )
			{
				shot_data.bullet[ empty_num ].flag = 1;
				shot_data.bullet[ empty_num ].kind = 1;//łAʔȂ̂Œe̎ނςBzgboss_data.bullet_kind̂؁B
				shot_data.bullet[ empty_num ].angle = ShotAtan2( boss_data.location, player_data.location );
				shot_data.bullet[ empty_num ].location.Set( boss_data.location.x, boss_data.location.y );
				shot_data.bullet[ empty_num ].count = 0;
				shot_data.bullet[ empty_num ].speed = 3;
				DX::dxCentral.PlayWaveSound( shotSound[ 0 ] );
			}
		}

		if( shot_data.count > 200 && shot_data.count < 300 && shot_data.count % 2 == 0 )
		{
			if( shot_data.flag != 2 && empty_num != -1 )
			{
				shot_data.bullet[ empty_num ].flag = 1;
				shot_data.bullet[ empty_num ].kind = 0;//łAʔȂ̂Œe̎ނςBzgboss_data.bullet_kind̂؁B
				shot_data.bullet[ empty_num ].angle = ShotAtan2( boss_data.location, player_data.location ) + RandomNumber( CIRCLE_RATIO / 4 );
				shot_data.bullet[ empty_num ].location.Set( boss_data.location.x, boss_data.location.y );
				shot_data.bullet[ empty_num ].count = 0;
				shot_data.bullet[ empty_num ].speed = 3 + RandomNumber( 1.5 );;
				DX::dxCentral.PlayWaveSound( shotSound[ 0 ] );
			}
		}

		if( shot_data.count > 300 && shot_data.count < 400 && shot_data.count % 20 == 0 )
		{
			for( int i = 0; i < 20; i++ )
			{
				empty_num = SearchEmptyBullet( &shot_data.bullet[ 0 ] );

				if( shot_data.flag != 2 && empty_num != -1 )
				{
					shot_data.bullet[ empty_num ].flag = 1;
					shot_data.bullet[ empty_num ].kind = boss_data.bullet_kind;
					shot_data.bullet[ empty_num ].angle = ShotAtan2( boss_data.location, player_data.location ) + CIRCLE_RATIO * 2 / 20 * i;
					shot_data.bullet[ empty_num ].location.Set( boss_data.location.x, boss_data.location.y );
					shot_data.bullet[ empty_num ].count = 0;
					shot_data.bullet[ empty_num ].speed = 4;
					DX::dxCentral.PlayWaveSound( shotSound[ 0 ] );
				}
			}
		}

		if( shot_data.count >= 500 )
		{
			shot_data.count = 0;
		}

		break;

	case 4:
		//20AˌA30JEgÂVbg@200JEg𒴂ł΂TA300JEgŉ~`˒ǉB TOOJEgōŏ̘A˂...i[vj
		if( ( shot_data.count < 200 && shot_data.count % 10 == 0 ) || ( shot_data.count >= 200 && shot_data.count % 30 == 0 ) )
		{
			empty_num = SearchEmptyBullet( &shot_data.bullet[ 0 ] );

			if( shot_data.flag != 2 && empty_num != -1 )
			{
				shot_data.bullet[ empty_num ].flag = 1;
				shot_data.bullet[ empty_num ].kind = 1;//łAʔȂ̂Œe̎ނςBzgboss_data.bullet_kind̂؁B
				shot_data.bullet[ empty_num ].angle = ShotAtan2( boss_data.location, player_data.location );
				shot_data.bullet[ empty_num ].location.Set( boss_data.location.x, boss_data.location.y );
				shot_data.bullet[ empty_num ].count = 0;
				shot_data.bullet[ empty_num ].speed = 3;
				DX::dxCentral.PlayWaveSound( shotSound[ 0 ] );
			}
		}

		if( shot_data.count > 300 && shot_data.count < 400 && shot_data.count % 2 == 0 )
		{
			if( shot_data.flag != 2 && empty_num != -1 )
			{
				shot_data.bullet[ empty_num ].flag = 1;
				shot_data.bullet[ empty_num ].kind = boss_data.bullet_kind;
				shot_data.bullet[ empty_num ].angle = ShotAtan2( boss_data.location, player_data.location ) + RandomNumber( CIRCLE_RATIO / 4 );
				shot_data.bullet[ empty_num ].location.Set( boss_data.location.x, boss_data.location.y );
				shot_data.bullet[ empty_num ].count = 0;
				shot_data.bullet[ empty_num ].speed = 3 + RandomNumber( 1.5 );;
				DX::dxCentral.PlayWaveSound( shotSound[ 0 ] );
			}
		}

		if( shot_data.count > 400 && shot_data.count < 500 && shot_data.count % 20 == 0 )
		{
			for( int i = 0; i < 20; i++ )
			{
				empty_num = SearchEmptyBullet( &shot_data.bullet[ 0 ] );

				if( shot_data.flag != 2 && empty_num != -1 )
				{
					shot_data.bullet[ empty_num ].flag = 1;
					shot_data.bullet[ empty_num ].kind = boss_data.bullet_kind;
					shot_data.bullet[ empty_num ].angle = ShotAtan2( boss_data.location, player_data.location ) + CIRCLE_RATIO * 2 / 20 * i;
					shot_data.bullet[ empty_num ].location.Set( boss_data.location.x, boss_data.location.y );
					shot_data.bullet[ empty_num ].count = 0;
					shot_data.bullet[ empty_num ].speed = 4;
					DX::dxCentral.PlayWaveSound( shotSound[ 0 ] );
				}
			}
		}

		if( shot_data.count >= 500 )
		{
			shot_data.count = 0;
		}

		break;
	}
}

//shot_num̃Vbgo^GƎlƂ̊pxԂB
double BossShotPattern::ShotAtan2( const Point& boss_loc, const Point& player_loc )
{
	return atan2( 
		player_loc.y - boss_loc.y,
		player_loc.x - boss_loc.x );
}

//󂢂Ăeۂ̌
int BossShotPattern::SearchEmptyBullet( const BulletData* bullet_data )
{
	if( bullet_data )
	{
		for( int i = 0; i < BULLET_DATA_MAX; i++ )
		{
			if( bullet_data[ i ].flag == 0 )
			{
				return i;
			}
		}

		return -1;
	}

	return -1;
}