#include "DxCentral.h"

//RXgN^
DxCentral::DxCentral( void )
{
}

//fXgN^
DxCentral::~DxCentral( void )
{
}

//
HRESULT DxCentral::Initialize( HWND hwnd, HINSTANCE hinst )
{
	//`foCX֘A
	if( dxDraw.Initialize( hwnd ) == E_FAIL )
	{
		return E_FAIL;
	}

	//L[foCX
	if( dxKeyInput.InitializeKeyDevice( hwnd, hinst ) != 0 )
	{
		return E_FAIL;
	}

	//XAudioGW
	if( dxAudio.InitializeXAudio() != 0 )
	{
		return E_FAIL;
	}

	return S_OK;
}

//Direct3DfoCX̍쐬@tXN[ (fobOł͂̃[h͊댯j
HRESULT DxCentral::InitializeFullScreen( HWND hwnd, HINSTANCE hinst )
{
	//`foCX֘A
	if( dxDraw.InitializeFullScreen( hwnd ) == E_FAIL )
	{
		return E_FAIL;
	}

	//L[foCX
	if( dxKeyInput.InitializeKeyDevice( hwnd, hinst ) != 0 )
	{
		return E_FAIL;
	}

	//XAudioGW
	if( dxAudio.InitializeXAudio() != 0 )
	{
		return E_FAIL;
	}

	return S_OK;
}

//tHgiMSSVbN̂݁@KvȂ΂ƂŕςjG[Ȃ-1@0
int DxCentral::InitializeFont( LPCTSTR font_name, int height, int width )
{
	return dxDraw.InitializeFont( font_name, height, width );
}

//`
int DxCentral::DrawString( LPCSTR draw_str, int left, int right, int top, int bottom )
{
	return dxDraw.DrawString( draw_str, left, right, top, bottom );
}

//eNX`̃[h  .bmpA.ddsA.dibA.jpgA.pngA .tga
int DxCentral::LoadTexture( LPCSTR filename )
{
	return dxDraw.LoadTexture( filename );
}

//ʂNA
void DxCentral::ClearScreen()
{
	dxDraw.ClearScreen();
}

//eNX``@G[Ȃ-1Ԃ
//index: int^@textureVector̃CfbNXiLoadĂKvB)
//src_  x & y & width & height: 摜̐؂oʒu Jn_i x, y )Awidth,heighẗʒu܂ł`\ƂBig~OƂƁj
//draw_  x & y & width & height: 摜XN[ɕ`ʒuA傫
int DxCentral::DrawTexture( int index, int src_x, int src_y, int src_width, int src_height, int draw_x, int draw_y, int draw_width, int draw_height )
{
	return dxDraw.DrawTexture( index, src_x, src_y, src_width, src_height, draw_x, draw_y, draw_width, draw_height );
}

//`IBobNobt@XN[ɔf@G[Ȃ-1Ԃ
int DxCentral::ScreenUpdate()
{
	return dxDraw.ScreenUpdate();
}

//waveTEh̓ǂݍ݁@ANZXL[Ԃ errorȂ-1Ԃ
int DxCentral::LoadWaveSound( LPTSTR filename, bool loopflag )
{
	return dxAudio.LoadWaveSound( filename, loopflag );
}

//TEh̍Đ G[Ȃ-1@O
int DxCentral::PlayWaveSound( int index )
{
	return dxAudio.PlayWaveSound( index );
}

//ʂݒ肷BG[-1
int DxCentral::SetSoundVolume( int index, float volume )
{
	return dxAudio.SetSoundVolume( index, volume );
}

//TEh̍폜
void DxCentral::DeleteSound( int index )
{
	dxAudio.DeleteSound( index );
}

//SẴTEh̍폜
void DxCentral::DeleteAllSound()
{
	dxAudio.DeleteAllSound();
}

//eNX`̍폜
void DxCentral::DeleteTexture( int delete_index )
{
	dxDraw.DeleteTexture( delete_index );
}

//SẴeNX`폜
void DxCentral::DeleteAllTexture()
{
	dxDraw.DeleteAllTexture();
}

//ǂݍݍς݂indexԍ̃eNX`̕Ԃ G[Ȃ-1
int DxCentral::GetTextureWidth( int index )
{
	return dxDraw.GetTextureWidth( index );
}

//ǂݍݍς݂indexԍ̃eNX`̍Ԃ G[Ȃ-1
int DxCentral::GetTextureHeight( int index )
{
	return dxDraw.GetTextureHeight( index );
}

//L[̏ԂԂ
const char* DxCentral::GetKeyState()
{
	return dxKeyInput.GetKeyState();
}

//L[JEgԂ
const int* DxCentral::GetKeyCount()
{
	return dxKeyInput.GetKeyCount();
}