#include "DxKeyInput.h"

//RXgN^@o
DxKeyInput::DxKeyInput( void ) : iDirectInput( NULL ),
	iDInputDevice( NULL )
{
	//₷̂memsetgpB肪ꍇ̓[vɂɐ؂ւ
	memset( inputKeys, 0, sizeof( inputKeys ) );
	memset( hitKeyCount, 0, sizeof( hitKeyCount ) );
}

//fXgN^@oJK{
DxKeyInput::~DxKeyInput( void )
{
	if( iDInputDevice != NULL )
	{
		iDInputDevice->Unacquire();
		SAFE_RELEASE( iDInputDevice );
	}

	if( iDirectInput != NULL )
	{
		SAFE_RELEASE( iDirectInput );
	}
}

//L[foCX@G[Ȃ-1 0
int DxKeyInput::InitializeKeyDevice( HWND hwnd, HINSTANCE hinst )
{
	//DirectInput̏@iL[͊Ǘj
	if( FAILED( DirectInput8Create( 
		hinst,
		DIRECTINPUT_VERSION,
		IID_IDirectInput8,
		( void** )&iDirectInput,
		NULL ) ) )
	{
		return -1;
	}

	//DirectInput̃foCX쐬@iL[͊Ǘj
	if( FAILED( iDirectInput->CreateDevice( GUID_SysKeyboard, &iDInputDevice, NULL ) ) )
	{
		return -1;
	}

	iDInputDevice->SetDataFormat( &c_dfDIKeyboard );//f[^̌`BL[{[h̏ꍇɂ
	iDInputDevice->SetCooperativeLevel( hwnd, DISCL_FOREGROUND | DISCL_NONEXCLUSIVE );//EBhEőOʂ̎̓`FbN@rANZX

	return 0;
}

//L[ԂԂB
const char* DxKeyInput::GetKeyState()
{
	HRESULT h_result = iDInputDevice->Acquire();

	if( ( h_result == DI_OK ) || ( h_result == S_FALSE ) )
	{
		iDInputDevice->GetDeviceState( sizeof( inputKeys ), &inputKeys );

		SetKeyCount();

		return inputKeys;
	}

	return NULL;
}

//L[JEgԂB
const int* DxKeyInput::GetKeyCount()
{
	return hitKeyCount;
}

////L[JEg`FbNZbg
void DxKeyInput::SetKeyCount()
{
	for( int i = 0; i < 256; i++ )
	{
		if( inputKeys[ i ] & 0x80 )//0x80̓L[Ă邩̊mFɎgp
		{
			hitKeyCount[ i ]++;
		}
		else
		{
			hitKeyCount[ i ] = 0;
		}
	}
}