#include "Ending.h"

namespace Sequence
{
	//RXgN^
	Ending::Ending( void ) : endingImage( 0 ),
		imageShowCount( 0 )
	{
		endingImage =  DX::dxCentral.LoadTexture( "./SettingFiles/Ending/EndingImage.png" );

		if( endingImage == -1 )
		{
			ErrorMsgBox( "Ending摜̓ǂݍ݂Ɏs܂B\nI܂B" );
			exit( -1 );
		}
	}

	//fXgN^
	Ending::~Ending( void )
	{
		DX::dxCentral.DeleteAllTexture();
		DX::dxCentral.DeleteAllSound();
	}

	//ʍXV
	void Ending::Update( SequenceCentral* central )
	{
		if( imageShowCount == 200 )
		{
			central->MoveSequence( NEXT_TITLE );
		}

		DX::dxCentral.DrawTexture(
			endingImage,
			0,
			0,
			WINDOW_SIZE_X,
			WINDOW_SIZE_Y,
			0,
			0,
			WINDOW_SIZE_X,
			WINDOW_SIZE_Y );

		imageShowCount++;
	}
}