// ============================================
// [Tv]
// GǗNX
//
// Copyright (C) 2012 Җ All rights reserved.
// ============================================

#ifndef ENEMY_H_INCLUDED_
#define ENEMY_H_INCLUDED_

#include <cassert>
#include <sstream>
#include "math.h"
#include "Struct.h"
#include "Common.h"
#include "XmlReader.h"
#include "EnemyMovePattern.h"
#include "EnemyShot.h"
#include "ExplosionEffect.h"

using namespace std;
using namespace CommonSpace;

class Enemy
{
public:
	//RXgN^
	Enemy( void );

	//fXgN^
	~Enemy( void );

	//
	void Initialize( int stage );

	//G̑S̊Ǘ
	void EnemyControl( int stage_count, const PlayerData* player );

	//G_[W炤
	int EnemyDamage( int enemy_num, int damage );

	//Gf[^ԂB
	const EnemyData* GetEnemyData() const;

	//GVbgf[^Ԃ
	const EnemyShotData* GetShotData() const;

	//ȇ傫Ԃ
	const vector<Size>* GetBulletSize() const;

private:
	//G摜`
	void DrawEnemyImage( int enemy_num );

	//Gf[^̓o^
	void RegisterData( int stage_count );

	//󂢂ĂGf[^̗vfԍԂ
	int EmptyEnemyNumber();

	//Gt@C̓ǂݍ
	void LoadEnemyFile( std::string filename );

	//Rs[RXgN^֎~
	Enemy( const Enemy& );

	//֎~
	Enemy& operator=( const Enemy& );

	std::vector<int> enemyImage;//GC[Wnh
	std::vector<std::string> fileName;//Gt@C
	std::vector<EnemyData> enData;//PXe[W̑SGf[^
	std::vector<int> soundHandle;//TEhnh
	EnemyData enShowData[ EN_SHOW_MAX ];//\\Gf[^ivfŒj
	EnemyMovePattern movePattern;//Gړp^[NX
	EnemyShot enemyShot;//VbgǗNX
	ExplosionEffect enemyEffect;//GGtFNgǗNX
};

#endif //ENEMY_H_INCLUDED_