#include "GameCentral.h"

//RXgN^
GameCentral::GameCentral( void )
{
	windowClass.cbSize = sizeof( WNDCLASSEX );
	windowClass.style = CS_CLASSDC;
	windowClass.lpfnWndProc = &GameCentral::WndProc;
	windowClass.cbClsExtra = 0L;
	windowClass.cbWndExtra = 0L;
	windowClass.hInstance = GetModuleHandle( NULL );
	windowClass.hIcon = NULL;
	windowClass.hCursor = NULL;
	windowClass.hbrBackground = NULL;
	windowClass.lpszMenuName = NULL;
	windowClass.lpszClassName = L"DirectX Sample";
	windowClass.hIconSm = NULL;

	RegisterClassEx( &windowClass );//EBhEo^

	windowHandle = CreateWindow( 
		L"DirectX Sample",
		L"DirectX Sample !!",
		WS_OVERLAPPEDWINDOW & ~WS_THICKFRAME & ~WS_MAXIMIZEBOX,
		( GetSystemMetrics( SM_CXSCREEN ) - WINDOW_SIZE_X ) / 2,
		( GetSystemMetrics( SM_CYSCREEN ) - WINDOW_SIZE_Y ) / 2,
		WINDOW_SIZE_X + GetSystemMetrics( SM_CXEDGE ) + GetSystemMetrics( SM_CXBORDER ) + GetSystemMetrics( SM_CXFIXEDFRAME ),
		WINDOW_SIZE_Y + GetSystemMetrics( SM_CYEDGE ) + GetSystemMetrics( SM_CYBORDER ) + GetSystemMetrics( SM_CYFIXEDFRAME ) + GetSystemMetrics( SM_CYCAPTION ),
		NULL,
		NULL,
		windowClass.hInstance,
		NULL );

	if( FAILED( DX::dxCentral.Initialize( windowHandle, windowClass.hInstance ) ) )
    {
		ErrorMsgBox( "DirectX̏Ɏs܂B\nI܂B" );
		exit( -1 );
	}

	if( !Sequence::SequenceCentral::GetInstance() )
	{
		Sequence::SequenceCentral::Create();//̍쐬
	}
}

//fXgN^
GameCentral::~GameCentral( void )
{
	UnregisterClass( L"DirectX Sample", windowClass.hInstance );
	Sequence::SequenceCentral::Destroy();//I
}

//Q[[v
void GameCentral::GameLoop( void )
{
	ShowWindow( windowHandle, SW_SHOWDEFAULT );
	UpdateWindow( windowHandle );

	while( TRUE )
	{
		// bZ[W邩ǂ
		if( PeekMessage( &windowMessage, NULL, 0, 0, PM_NOREMOVE ) )
		{
			// bZ[W擾AWM_QUITǂ
			if( !GetMessage( &windowMessage, NULL, 0, 0 ) )
			{
				break;
			}

			TranslateMessage( &windowMessage );//L[{[hp\ɂ
			DispatchMessage( &windowMessage );//Windowsɖ߂
		}
		else//ȂȂQ[ ̏̓V[PXNX󂯂
		{
			DX::dxCentral.ClearScreen();//ʂ̃NA
			Sequence::SequenceCentral::GetInstance()->Update();
			DX::dxCentral.ScreenUpdate();
		}
	}
}

//EBhEvV[W
LRESULT WINAPI GameCentral::WndProc( HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam )
{
	switch( msg )
	{
	case WM_DESTROY:
		PostQuitMessage( 0 );
		return 0;
	case WM_PAINT:
		DX::dxCentral.ScreenUpdate();
		ValidateRect( hwnd, NULL );
		return 0;//ɕԂB(jȂȂDefWindowProcɓnRenderłȂ
	}

	return DefWindowProc( hwnd, msg, wparam, lparam );
}