// ============================================
// [Tv]
// vC[ǗNX
//
// Copyright (C) 2012 Җ All rights reserved.
// ============================================

#ifndef PLAYER_H_INCLUDED_
#define PLAYER_H_INCLUDED_

#include <cassert>
#include "math.h"
#include "Struct.h"
#include "Common.h"
#include "PlayerShot.h"

using namespace CommonSpace;

class Player
{
public:
	//RXgN^
	Player( void );

	//fXgN^
	~Player( void );

	//vC[
	void Initialize( int );

	//SmF@trueȂcO
	bool CheckDeath() const;

	//vC[SB(classfXgNgƂƂł͂ȂBj
	void PlayerDeath();

	//vC[VbgLZ
	void ShotCancel( int shot_num );

	//vC[̑S̊Ǘ
	void PlayerControl( const KeyData* key_data );

	//vC[̈ʒuԂB
	const PlayerData* GetPlayerData() const;

	//vC[Vbg̈ʒuԂB
	const PlayerShotData* GetShotData() const;

private:
	//vC[C[W̕`
	void DrawPlayerImage();

	//vC[C[W̕ύX
	void ChangePlayerImage();

	//Rs[RXgN^̋֎~ `ł悢
	Player( const Player& );

	//Rs[Zq̋֎~ `ł悢
	Player& operator=( const Player& );

	int playerImage;//vC[摜nh
	int lifeImage;//c摜nh
	int deathSound;//S̍ۂ̉nh
	int fireTime;//VbgˊԊu
	static int lifeCount;//CtiXe[W܂邽߁B[݌v~X]j
	RectData imageRect;//\摜̔ԍ
	PlayerData playerData;//vC[̃f[^
	PlayerShot playerShot;//VbgǗNX
};

#endif //PLAYER_H_INCLUDED_