// ============================================
// [Tv]
// vC[VbgǗNX
//
// Copyright (C) 2012 Җ All rights reserved.
// ============================================

#ifndef PLAYER_SHOT_H_INCLUDED_
#define PLAYER_SHOT_H_INCLUDED_

#include <cassert>
#include "Struct.h"
#include "Common.h"

using namespace CommonSpace;

class PlayerShot
{
public:
	//RXgN^
	PlayerShot( void );

	//fXgN^
	~PlayerShot( void );

	//VbgS̊Ǘ
	void ShotControl();

	//Vbg̓o^
	void RegisterShot( const Point* location );

	//Vbg̃LZij
	void ShotCancel( int shot_num );

	//Vbgf[^ԂB
	const PlayerShotData* GetShotData() const;

private:
	//Vbg̕`
	void DrawShot() const;

	//󂢂Ăeۂ̌ G[Ȃ-1ԂBȊOȂ󂫗vfԍԂ
	int SearchEmptyShot() const;

	//Vbg̏
	void PrepareShot( const Point* location );

	//Vbg̈ʒuvZ
	void CalcShot();

	//Rs[RXgN^̋֎~ `ł悢
	PlayerShot( const PlayerShot& );

	//Rs[Zq̋֎~ `ł悢
	PlayerShot& operator=( const PlayerShot& );

	int shotImage;//Vbg摜nh
	int shotSound;//Vbgnh
	int rapidFire;//˒e
	TemplatePoint<int> drawLocation[2];//eە`ʒu
	PlayerShotData shotData[ PLAYER_SHOT_MAX ];//Vbgf[^
};

#endif //PLAYER_SHOT_H_INCLUDED_