#include "Score.h"

int Score::nowScore = 0;

Score::Score( void ) : upDate( false ),
	highScore( 0 )
{
	DX::dxCentral.InitializeFont( L"M12_MACH BIKER", 12, 12 );
	LoadHighScore();
}

Score::~Score( void )
{
	CompareHighScore();
}

//
void Score::NowScoreInitialize()
{
	nowScore = 0;
}

//XRAǗ
void Score::ScoreControl()
{
	if( nowScore > highScore )
	{
		highScore = nowScore;
		upDate = true;
	}

	DrawScore();
}

//XRAZ
void Score::AddScore( int add_score )
{
	nowScore += add_score;
}

//`
void Score::DrawScore()
{	
	std::ostringstream now_score_stream;
	std::ostringstream high_score_stream;

	now_score_stream.setf( std::ios::right );
	now_score_stream.fill( '0' );
	now_score_stream.width( 8 );
	high_score_stream.setf( std::ios::right );
	high_score_stream.fill( '0' );
	high_score_stream.width( 8 );

	now_score_stream << nowScore;
	high_score_stream << highScore;

	DX::dxCentral.DrawString( now_score_stream.str().c_str(), 450, 750, 50, 150 );
	DX::dxCentral.DrawString( high_score_stream.str().c_str(), 450, 750, 170, 250 );
}

//nCXRAXVǂmFAXVȂۑ
void Score::CompareHighScore()
{
	if( upDate == true )
	{
		std::ofstream fout( "./SettingFiles/HighScore/HighScore.txt" );

		if( !fout )
		{
			ErrorMsgBox( "XRAt@CJ܂B" );
			exit( -1 );
		}

		fout << nowScore << endl;
		
		fout.close();
	}
}

//XRAt@C̓ǂݍ
void Score::LoadHighScore()
{
	std::ifstream fin( "./SettingFiles/HighScore/HighScore.txt" );
	std::stringstream s_stream;
	std::string str;

	if( !fin )
	{
		ErrorMsgBox( "XRAt@CJ܂B" );
		exit( -1 );
	}

	fin >> str;
	s_stream << str;
	s_stream >> highScore;
	
	fin.close();
}