// ============================================
// [Tv]
// \̐錾
//
// Copyright (C) 2012 Җ All rights reserved.
// ============================================

#ifndef STRUCT_H_INCLUDED_
#define STRUCT_H_INCLUDED_

#include "Common.h"

using namespace CommonSpace;

template <typename T>
struct TemplatePoint
{
	//RXgN^
	TemplatePoint()
	{
		//̂ǂꂩ̌^0T|[gAȊO͎ȐӔCie^̃ftHgjƂB
		if( typeid( T ) == typeid( int ) ||
			typeid( T ) == typeid( float ) ||
			typeid( T ) == typeid( double ) ||
			typeid( T ) == typeid( unsigned int ) )
		{
			x = T( 0 );
			y = T( 0 );
		}
	}

	void Set( T temp_x, T temp_y ) { x = temp_x; y = temp_y; }

	T x;
	T y;
};

struct Size
{
	//RXgN^
	Size() : width( 0 ), height( 0 ){}
	explicit Size( int param ) : width( param ), height( param ){}
	explicit Size( int temp_width, int temp_height ) { width = temp_width; height = temp_height; }

	void Set( int temp_width, int temp_height ) { width = temp_width; height = temp_height; }

	int width;
	int height;
};

//QWɎgp@g݂TemplatePointɍւB̏ꍇ͊eoGetPointn͑SĕύXȂ΂ȂȂB
struct Point
{
	//RXgN^
	Point() : x( 0.0 ), y( 0.0 ){}
	explicit Point( double param ) : x( param ), y( param ){}
	void Set( double temp_x, double temp_y ) { x = temp_x; y = temp_y; }

	double x;
	double y;
};

typedef struct Point Vector2D;//|Cg̕ʖ

//lp`̍ƉE̍W
struct RectData
{
	//RXgN^
	RectData() : top( 0 ), left( 0 ), bottom( 0 ), right( 0 ){}
	explicit RectData( int t_top, int t_left, int t_bottom, int t_right )
	{
		top = t_top;
		left = t_left;
		bottom = t_bottom;
		right = t_right;
	}

	void Set( int t_top, int t_left, int t_bottom, int t_right )
	{
		top = t_top;
		left = t_left;
		bottom = t_bottom;
		right = t_right;
	}

	int top;
	int left;
	int bottom;
	int right;
};

//l̃f[^
struct PlayerData
{
	//RXgN^
	PlayerData() : flag( 0 ), 
		count( 0 ),
		invincible_count( 0 ),
		shot_count( 0 ), 
		life( 0 ),
		size( 70 ),
		location(){}

	int flag;//tO
	int count;//JE^
	int invincible_count;//GԃJE^
	int shot_count;//VbgJE^
	int life;//c
	Size size;//TCY
	Point location;//ʒu
};

//G̃f[^
struct EnemyData
{
	//RXgN^@͑...܂Ȃ̂
	EnemyData()
	{
		Initialize();
	}

	//Xe[WƂ̏Ɏgp
	void Initialize()
	{
		flag = 0;
		count = 0;
		pattern = 0;
		direction = 0;
		kind = 0;
		effect = 0;
		hitpoint = 0;
		barrage_time = 0;
		barrage_kind = 0;
		bullet_kind = 0;
		wait_time = 0;
		speed = 0.0;
		angle = 0.0;
		location.Set( 0.0, 0.0 );
		vec_speed.Set( 0.0, 0.0 );
		image_size.Set( 0, 0 );
		image_rect.Set( 0, 0, 0, 0 );
	}


	int flag;//tO
	int count;//JE^
	int pattern;//ړp^[
	int direction;// 0 1 2E
	int kind;//
	int effect;//GtFNg
	int hitpoint;//HP
	int barrage_time;//eJn
	int barrage_kind;//e
	int bullet_kind;//e̎
	int wait_time;//ҋ@
	double speed;//x
	double angle;//px
	Point location;//ʒu
	Vector2D vec_speed;//xxNg
	Size image_size;//̂̉摜TCY
	RectData image_rect;//`̍ێgpC[WRect
};

//{Xf[^
typedef struct EnemyData BossData;

//vC[Vbgf[^
struct PlayerShotData
{
	//RXgN^ ͑...܂Ȃ̂
	PlayerShotData()
	{
		Initialize();
	}

	//Xe[WƂ̏Ɏgp
	void Initialize()
	{
		flag = 0;
		count = 0;
		kind = 0;
		power = 0;
		angle = 0.0;
		speed = 0.0;
		location.x = 0.0;
		location.y = 0.0;
		size.Set( 16, 16 );
	}

	int flag;//tO
	int count;//JE^
	int kind;//
	int power;//U
	double angle;//px
	double speed;//x
	Point location;//Vbgʒu
	Size size;//VbgTCY
};

//ẽf[^
struct BulletData
{
	//RXgN^
	BulletData()
	{
		Initialize();
	}

	//Xe[WƂ̏Ɏgp
	void Initialize()
	{
		flag = 0;
		count = 0;
		kind = 0;
		state = 0;
		effect = 0;
		angle = 0.0;
		base_angle = 0.0;
		speed = 0.0;
		temp_speed = 0.0;
		location.x = 0.0;
		location.y = 0.0;
	}

	int flag;//tO
	int count;//JE^
	int kind;//
	int state;//
	int effect;//GtFNgԍ g񂩂...
	double angle;//e̊px
	double base_angle;//x[Xpx
	double speed;//ȇx
	double temp_speed;//ꎞ@x
	Point location;//ʒuW
};

//GVbgf[^
struct EnemyShotData
{
	//RXgN^
	EnemyShotData() : bullet( BULLET_DATA_MAX )
	{
		Initialize();//͑...܂Ȃ̂
	}

	//Xe[WƂ̏Ɏgp
	void Initialize()
	{
		flag = 0;
		enemy_num = 0;
		count = 0;
		kind = 0;
		power = 0;
		angle = 0.0;
		speed = 0.0;
		location.x = 0.0;
		location.y = 0.0;

		for( int i = 0; i < BULLET_DATA_MAX; i++ )
		{
			bullet[ i ].Initialize();
		}
	}

	int flag;//tO@0͖o^A\ȂB@1̓Vbgo^B\B@2͒eo^sԁ@ɔˍς݂̒e͌vZ\
	int enemy_num;//̃VbgɑΉGԍ
	int count;//JE^
	int kind;//
	int power;//U
	double angle;//px
	double speed;//x
	Point location;//Vbgʒu
	//BulletData bullet[ BULLET_DATA_MAX ];//ef[^ X^bNI[o[t[...BULLET_DATA_MAX300ȉɂ邩vector|C^łȂǂ̉KvB
	std::vector<BulletData> bullet;//ef[^@RXgN^ŃTCYmB@BULLET_DATA_MAX̌Œ蕝ƂĎgpB
};

//{XVbgf[^
struct BossShotData
{
	BossShotData() : bullet( BULLET_DATA_MAX )
	{
		Initialize();
	}

	void Initialize()
	{
		flag = 0;
		count = 0;
		kind = 0;
		angle = 0.0;
		speed = 0.0;

		for( int i = 0; i < BULLET_DATA_MAX; i++ )
		{
			bullet[ i ].Initialize();
		}
	}

	int flag;//tO
	int count;//JE^
	int kind;//Vbg
	double angle;//px
	double speed;//x
	std::vector<BulletData> bullet;
};

//C[Wf[^\́@C[WnhƃTCY@(̂قy...j
struct ImageData
{
	ImageData() : image( -1 ), size(), one_size(){}
	explicit ImageData( int img_num, Size img_size, Size img_one_size )
	{ 
		image = img_num;
		size.Set( img_size.width, img_size.height );
		one_size.Set( img_one_size.width, img_one_size.height );
	}

	int image;//C[Wnh
	Size size;//摜Ŝ̃TCY
	Size one_size;//̉摜TCY	
};

//GtFNgf[^
struct EffectData
{
	EffectData() : flag( 0 ), count( 0 ), kind( 0 ), location(), rect(){}
	void Initialize(){ flag = 0; count = 0; kind = 0; location.Set( 0.0, 0.0 ); rect.Set( 0, 0, 0, 0 ); }

	int flag;//tO@0͂ȂɂȂBPŕ\
	int count;//JE^
	int kind;//GtFNg
	Point location;//ʒu
	RectData rect;//`̍ۂɎgp̂̃TCY
};

//LL[f[^
struct KeyData
{
	//RXgN^
	KeyData() : left( 0 ),
		right( 0 ),
		down( 0 ),
		up( 0 ),
		shot( 0 ){}

	int left;//L[
	int right;//EL[
	int down;//L[
	int up;//L[
	int shot;//VbgL[
};

#endif //STRUCT_H_INCLUDED_